'=========================================================================
' Waermeleitungsgleichung
' WAERME.BAS
'=========================================================================

#INCLUDE "Inc\3D-Graph.bas"

DIM AS DOUBLE t(20), x(10), Temp(20, 10), a, xmax, b, dx, dt
DIM AS INTEGER i, j
DIM AS STRING*1 jn

Anfang:
SCREEN 0
COLOR 7, 1
CLS
PRINT "Loesung der Waermeleitungsgleichung fuer sinusfoermige Randbedingung"
PRINT
PRINT "Vgl. Vogel: Probleme aus der Physik, Aufgabe 5.4.5"
PRINT
PRINT "Auf der Aussenflaeche einer Wand folgt die Temperatur im Tagesverlauf"
PRINT "naeherungsweise der Funktion"
PRINT "T = T0 + T1 * sin(omega * t)"
PRINT "Die Loesung der Waermeleitungsgleichung liefert dann im Inneren der Wand"
PRINT "den Temperaturverlauf"
PRINT "T = T0 + T1 * exp(-a * x) * sin(omega * t - a * x),"
PRINT "wobei a eine Konstante ist,"
PRINT "d.h. die Temperatur im Wandinnern folgt der Aussentemperatur verzoegert"
PRINT "und mit gedaempfter Amplitude."
PRINT
INPUT "a im Verhaeltnis zur Wanddicke: ", a

xmax = 5
b = a / xmax
dx = xmax / 10
dt = 2 * pi / 20

FOR i = 0 TO 20
  t(i) = i * dt
  FOR j = 0 TO 10
    x(j) = j * dx
    Temp(i, j) = EXP(-b * x(j)) * SIN(t(i) - b * x(j))
  NEXT j
NEXT i

rem WINDOWTITLE "Temperaturverteilung T(x, t) fuer a = " + STR(a) + ", T0 = 0 gesetzt" 
SCREEN 18
COLOR 0, 15
CLS

OutText(320, 400, "Temperaturverteilung T(x, t) fuer a = " + STR(a) + ", T0 = 0 gesetzt", "z", "u")
VIEW (50, 50) - (590, 380),, 1
WINDOW(-1, -2.5) - (8, 3)
Koordinaten3D (0, 2 * pi, 0, 5, -1, 1, -20, 20, "t", "x", "T")
xyzGraphik(t(), x(), Temp(), -20, 20, 12)
LOCATE 29, 30
INPUT "Nochmal j/n: ", jn
IF UCASE(jn) = "J" THEN GOTO Anfang


